/* Solaris wrappers for the nss_db module.
   Copyright (C) 2011 Mark R. Bannister <cambridge@users.sourceforge.net>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If not,
   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

#include <config.h>
#include <nss_dbdefs.h>
#include <grp.h>
#include <sys/types.h>

#include "nss_db.h"

/* Prototypes for common wrappers */
extern nss_backend_t *_nss_db_constr (nss_backend_op_t [], int);
extern nss_status_t _nss_db_destr (nss_backend_t *, void *);
extern nss_status_t _nss_db_str2ent (void *, nss_XbyY_args_t *);
extern int _nss_db_str2ent_grp (char *, struct group *, void *,
					size_t, int *, nss_str2ent_t);

#  define _nss_files_parse_grent(line, grp, buffer, buflen, errnop) \
                _nss_db_str2ent_grp (line, grp, buffer, buflen, errnop, str2ent)

/* Prototypes for Linux-style functions */
extern enum nss_status _nss_db_setpwent (int);
extern enum nss_status _nss_db_endpwent (void);
extern enum nss_status _nss_db_getpwent_r (void *, void *, size_t, int *);
extern enum nss_status _nss_db_getpwnam_r (const char *, void *, void *,
								size_t, int *);
extern enum nss_status _nss_db_getpwuid_r (ulong_t, void *, void *,
								size_t, int *);

extern enum nss_status _nss_db_setspent (int);
extern enum nss_status _nss_db_endspent (void);
extern enum nss_status _nss_db_getspent_r (void *, void *, size_t, int *);
extern enum nss_status _nss_db_getspnam_r (const char *, void *, void *,
								size_t, int *);

extern enum nss_status _nss_db_setgrent (int);
extern enum nss_status _nss_db_endgrent (void);
extern enum nss_status _nss_db_getgrent_r (void *, void *, size_t, int *);
extern enum nss_status _nss_db_getgrnam_r (const char *, void *, void *,
								size_t, int *);
extern enum nss_status _nss_db_getgrgid_r (ulong_t, void *, void *,
								size_t, int *);
extern enum nss_status _nss_db_initgroups_dyn (const char *, gid_t,
					long int *, long int *, gid_t **,
					long int, int * EXTRA_INITGROUP_ARGS);
